//NICULAE Brindusa Ioana 331CA

#include <avr/io.h>
#include <avr/pgmspace.h>
#include <util/delay.h>
#include <stdlib.h>
#include <util/delay.h>
#include <avr/interrupt.h>

#include "pcd8544.h"
#include "avatar.h"
#include "Note.h"

#define LED_PORT PORTA
#define LED_DDR DDRA

#define GREEN_HUNGER_PIN PA0
#define GREEN_SLEEP_PIN PA1
#define GREEN_BATH_PIN PA2
#define GREEN_HAPPY_PIN PA3

#define RED_HUNGER_PIN PA4
#define RED_SLEEP_PIN PA5
#define RED_BATH_PIN PA6
#define RED_DYING_PIN PA7

#define FEED 1
#define PUT_TO_SLEEP 2
#define CLEAN 3

#define NOT_IN_MENU 0

#define BUTTON_PORT PORTB
#define BUTTON_DDR DDRB
#define BUTTON_PIN PINB
#define SELECT_STATE PB4
#define ADD_STATE PB3
#define SUB_STATE PB2

#define AUX_PORT PORTB
#define AUX_DDR DDRB
#define BUZZER PB0
#define MOTTO PB1

#define TOO_LOW 20
#define HAPPY_LEVEL 80

byte sad_beep[]={
	DO2, PATRIME,	
	STOP
};

void set_output_pins() {
	
}
void init_buzzer()
{
	SET(AUX_DDR, BUZZER);
	
	CLR(TCCR1B, WGM13);
	SET(TCCR1B, WGM12);
	CLR(TCCR1A, WGM11);
	CLR(TCCR1A, WGM10);
	
	//Prescaler /64
	CLR(TCCR1B,CS12);
	SET(TCCR1B,CS11);
	SET(TCCR1B,CS10);
}

void init_motto()
{
	SET(AUX_DDR, MOTTO);
}

void cry(byte* song)
{
	//Timmer start
	CLR(TCCR1A, COM1A1);
	SET(TCCR1A, COM1A0);
	
	byte* start = song;
	byte legatto = LEGATTO_OFF;
	
	while(1) 
	{
		switch(*song) 
		{
			case LEGATTO_ON:
				legatto = LEGATTO_ON;
				song++;
				break;
			case LEGATTO_OFF:
				legatto = LEGATTO_OFF;
				song++;
				break;
			case STOP:
				CLR(TCCR1A, COM1A1);
				CLR(TCCR1A, COM1A0);
				return;
				break;
			case REPETA:
				song = start;
				break;
			default:
				OCR1A = (*song);
				song++;
				//_delay_ms((int)(TEMPO/(*song)));
				song++;
				if(legatto == LEGATTO_OFF)
					{
				
					CLR(TCCR1A, COM1A1);
					CLR(TCCR1A, COM1A0);
					_delay_ms(1);
					TCNT1=0;
					CLR(TCCR1A, COM1A1);
					SET(TCCR1A, COM1A0);
					}
				break;
		}
	}
}

void be_happy()
{
	AUX_PORT = AUX_PORT ^ (1 < MOTTO);
}

int main()
{
	LED_DDR |=(1 << GREEN_HUNGER_PIN);
	LED_DDR |=(1 << GREEN_SLEEP_PIN);
	LED_DDR |=(1 << GREEN_BATH_PIN);
	LED_DDR |=(1 << GREEN_HAPPY_PIN);
	LED_DDR |=(1 << RED_HUNGER_PIN);
	LED_DDR |=(1 << RED_SLEEP_PIN);
	LED_DDR |=(1 << RED_BATH_PIN);
	LED_DDR |=(1 << RED_DYING_PIN);

	/*Testez LED-urile
	while(1){
	 	LED_PORT |= (1<<GREEN_HUNGER_PIN);
		LED_PORT |= (1<<GREEN_SLEEP_PIN);
		LED_PORT |= (1<<GREEN_BATH_PIN);
		LED_PORT |= (1<<GREEN_HAPPY_PIN);
		LED_PORT |= (1<<RED_HUNGER_PIN);
		LED_PORT |= (1<<RED_SLEEP_PIN);
		LED_PORT |= (1<<RED_BATH_PIN);
		LED_PORT |= (1<<RED_DYING_PIN);		
	 	_delay_ms(500);
	}
	*/

	//Testez LCD-ul
	/*
	 LcdInit();
    //display image
    LcdContrast(0x7F);
    LcdClear();
    LcdImage(bunny); 
    LcdUpdate();
    _delay_ms(2500);
	*/
	
	int hunger_level = 50;
	int sleep_level = 50;
	int clean_level = 50;
	
	byte option = NOT_IN_MENU;
	
	srandom(0);
	int r;
	
    LcdInit();
	init_buzzer();
	init_motto();
	
	int general_mood = 0;
	while(1) 
	{
		//Daca nu sunt in meniu, ii schimb starea;
		if(option == NOT_IN_MENU) 
		{
			r = random() % 3000;
			
			if(r % 3 == 0)
			{
			
				hunger_level -= 10;
				if(hunger_level < 50)
				{
					//light_up(RED_HUNGER_PIN);
					LED_PORT |= (1<<RED_HUNGER_PIN);
						
				} else if (hunger_level > 80)
						//light_up(GREEN_HUNGER_PIN);
						LED_PORT |= (1<<GREEN_HUNGER_PIN);
					else 
					{
						//shut_down(RED_HUNGER_PIN);
						//shut_down(GREEN_HUNGER_PIN);
						if((LED_PORT & (1<<GREEN_HUNGER_PIN)) == 1)
							LED_PORT |= (1<<GREEN_HUNGER_PIN);
						if((LED_PORT & (1<<RED_HUNGER_PIN)) == 1)
							LED_PORT |= (1<<RED_HUNGER_PIN);
					}
			}				
			else if(r % 5 == 0)
			{
				sleep_level -= 10;
				if(sleep_level < 50)
				{
					//light_up(RED_SLEEP_PIN);
					LED_PORT |= (1<<RED_SLEEP_PIN);
				} else if (sleep_level > 80)
						//light_up(GREEN_SLEEP_PIN);
						LED_PORT |= (1<<GREEN_SLEEP_PIN);
					else 
					{
						//shut_down(RED_SLEEP_PIN);
						//shut_down(GREEN_SLEEP_PIN);
						if((LED_PORT & (1<<GREEN_SLEEP_PIN)) == 1)
							LED_PORT |= (1<<GREEN_SLEEP_PIN);
						if((LED_PORT & (1<<RED_SLEEP_PIN)) == 1)
							LED_PORT |= (1<<RED_SLEEP_PIN);
					}
				
			}	
			else if(r % 7 == 0)
			{
				clean_level -= 15;
				if(clean_level < 50)
				{
					//light_up(RED_BATH_PIN);
					LED_PORT |= (1<<RED_BATH_PIN);
				} else if (clean_level > 80)
						//light_up(GREEN_BATH_PIN);
						LED_PORT |= (1<<GREEN_BATH_PIN);
					else 
					{
						//shut_down(RED_BATH_PIN);
						//shut_down(GREEN_BATH_PIN);
						if((LED_PORT & (1<<RED_BATH_PIN)) == 1)
							LED_PORT |= (1<<RED_BATH_PIN);
						if((LED_PORT & (1<<GREEN_BATH_PIN)) == 1)
							LED_PORT |= (1<<GREEN_BATH_PIN);
					}
			}
			
			general_mood = hunger_level + sleep_level + clean_level;
			
			if(general_mood > HAPPY_LEVEL)
			{
				//light_up(GREEN_HAPPY_PIN);
				LED_PORT |= (1<<GREEN_HAPPY_PIN);
				be_happy();
				LcdImage(happy_bunny); 
			} else if (general_mood < TOO_LOW)
				{
					//light_up(RED_DYING_PIN);
					LED_PORT |= (1<<RED_DYING_PIN);
					cry(sad_beep);
					LcdImage(sad_bunny); 
				
				} 
				else if (hunger_level < TOO_LOW)
				{
					LcdImage(hungry_bunny); 

				}
				else 
				{
					//shut_down(GREEN_HAPPY_PIN);
					//shut_down(RED_DYING_PIN);
					if((LED_PORT & (1<<GREEN_HAPPY_PIN)) == 1)
						LED_PORT |= (1<<GREEN_HAPPY_PIN);
					if((LED_PORT & (1<<RED_DYING_PIN)) == 1)
						LED_PORT |= (1<<RED_DYING_PIN);
					LcdImage(bunny);
				}
						//daca nu sunt in meniu si apas PB0 atunci intru in meniu
			if (!( BUTTON_PIN & (1<<SELECT_STATE)))
			{
				option = FEED;
				_delay_ms(500);
			}	
		
		}
		else 
		{
			//Aleg starea pe care vreau sa o modific
			if( !(BUTTON_PIN & (1 << SELECT_STATE))) 
			{
				option++;
				_delay_ms(500);
			}
			
			//Operatii de add asupra starii
			if( !(BUTTON_PIN & (1 << ADD_STATE)))
			{
				switch(option) 
				{
					case FEED: 
						hunger_level += 5;
						break;	
					case PUT_TO_SLEEP:
						sleep_level += 5;
						break;
					case CLEAN:
						clean_level += 5;
						break;
					default:
						break;
				}
			option = NOT_IN_MENU;
			_delay_ms(500);
			}
			
			//Operatii de subb asupra starii
			if( !(BUTTON_PIN & (1 << SUB_STATE)))
			{
				switch(option) 
				{
					case FEED: 
						hunger_level -= 5;
						break;	
					case PUT_TO_SLEEP:
						sleep_level -= 5;
						break;
					case CLEAN:
						clean_level -= 5;
						break;
					default:
						break;
				}
			option = NOT_IN_MENU;
			_delay_ms(500);
			}
		
		}
			
			
	}
	
	LcdUpdate();
    return 0;
}
